#ifndef _MULTEG_H
#define _MULTEG_H

#include <vector>
#include "example.h"
#include "parse.h"
#include "semanticParser.h"

class egId {
   public:
      int nli, ci;
      double conf;

      egId(int nlip, int cip) {
	 nli = nlip;
	 ci = cip;
	 conf = 0;
      }

      bool operator < (const egId &other) const {
	 return conf > other.conf;
      }
};

class multEg {
   int id;

   public:
   vector <string> nl;
   vector <string> orig_nl;
   vector <int> mci;

   multEg(int pid, const vector <string> &pnl, const vector <int> &pmci) {
      id = pid;
      nl = pnl;
      mci = pmci;
      /*
      if (mci.size() > 0) {
         int r = (int)(drand48()*mci.size());
         mci[0] = mci[r];
	 mci.resize(1);
      }*/
   }

   ostream &write(ostream &out) const;
};

inline ostream& operator << (ostream& out, const  multEg& t) {
       return t.write(out);
}


void readMultEgs(vector <multEg> &megs, const string &filename, const mrlParser &mp);
   
void mult_train_test(vector <multEg> &megs, vector <example> &testEg);
void mult_train_test_repl(vector <multEg> &megs, vector <example> &testEg);
//void mult_divide_train_test(vector <multEg> &megs, int d, vector <example> &testEg);


#endif
