#include <cassert>
#include "parse.h"
#include "util.h"

std::string readWord(FILE *file) {
   std::string s;
   char c;

      c = getc(file);
      while ((c==' ')||(c=='\n')||(c=='\t')) {
         c = getc(file);
       }

       while ((c != EOF) && (c!=' ')&&(c!='\n')&&(c!='\t')) {
           s.push_back(c);
           c = getc(file);
       }
#ifdef _GEO
   return decap(s);   
#endif
#ifndef _GEO
   return s;   
#endif
}

void readNl(FILE *file, vector <std::string> &nl) {
   std::string s;

   s = readWord(file);
   assert(s=="<nl>");
   
   s = readWord(file);
   while (s != "</nl>") {
      nl.push_back(s);
      s = readWord(file);
   }
}

bool readExample(ifstream &in, int &id, vector <std::string> &nl, vector <clang> &mcl, const mrlParser &mp) {
    std::string s, sid;
    while (in && s != "<example") {
       in>>s;
    }
    if (s != "<example") return false;

    in>>s;
    for (int i=4; i<s.length()-2; ++i) {
       sid.push_back(s[i]);
    }
    id = atoi(sid.c_str());
    
    in>>s;
    assert(s=="<nl>");
    while (s != "</nl>") {
       in>>s;
       if (s != "</nl>") nl.push_back(s);
    }
    
    in>>s;

    while (s != "</example>") {
       if (s=="<sem" || s=="<sem>") {
          if (s=="<sem") {
             in>>s;
          }
	  clang clg;
	  mp.readMrl(in,clg);
	  clg.getAllRootProd();
          in>>s;
          mcl.push_back(clg);
       }
    }
    return s=="</example>";
}

bool readExample(ifstream &in, int &id, vector <std::string> &nl, vector <clang> &mcl, double &conf, const mrlParser &mp) {
    std::string s, sid;
    while (in && s != "<example") {
       in>>s;
    }
    if (s != "<example") return false;

    in>>s;
    for (int i=4; i<s.length()-2; ++i) {
       sid.push_back(s[i]);
    }
    id = atoi(sid.c_str());
    
    in>>s;
    assert(s=="<nl>");
    while (s != "</nl>") {
       in>>s;
       if (s != "</nl>") nl.push_back(s);
    }
    
    in>>s;

    if (s=="<conf>") {
       in>>conf;
       in>>s;
       assert(s=="</conf>");
       in>>s;
    }

    while (s != "</example>") {
       if (s=="<sem" || s=="<sem>") {
          if (s=="<sem") {
             in>>s;
          }
	  clang clg;
	  mp.readMrl(in,clg);
	  clg.getAllRootProd();
          in>>s;
          mcl.push_back(clg);
       }
    }
    return s=="</example>";
}
