#include <iostream>
#include <cassert>
#include "stringClassifier.h"

extern vector <vector <int> > nli;
extern vector <string> n2s;

void stringClassifier::train(const vector <pn> &pos, const vector <pn> &neg, const production &p) {
   cp = p;
   if (cp.learnable) { 
      if (pos.size() != 0 && neg.size() != 0) {
	 c.train(pos, neg);
      }
      else {
         if (pos.size()==0) {
	    nopos=true;
         }
         if (neg.size()==0) {
	    noneg=true;
         }
      }
   }
   double l = 1;
   lim = 0;
   /*
   for (int i=0; i<pos.size(); ++i) {
      double r=giveProb(nli[pos[i].i]);
     // cout<<" "<<r<<"\n";
      if (r < l) l = r;
   }
   lim = l/4;
   */
   trained = true;
   //cout<<lim<<"\n";
}


void stringClassifier::train_semi(const vector <pn> &pos, const vector <pn> &neg, const vector <pn> &un, const production &p) {
   cp = p;
   if (cp.learnable) { 
      if (pos.size() != 0 && neg.size() != 0) c.train_semi(pos, neg, un);
      else {
         if (pos.size()==0) {
	    nopos=true;
         }
         if (neg.size()==0) {
	    noneg=true;
         }
      }
   }
   double l = 1;
   lim = 0;
   trained = true;
   //cout<<lim<<"\n";
}

     
/*
double stringClassifier::giveProb(const vector <int> &st) const {
   return giveProb(0,st.size()-1,st);
}*/

double stringClassifier::giveProb(example &eg) const {
   if (cp.learnable) {
      return giveProb(0,eg.nli.size()-1,eg);
   }
   else {
      return giveProb(0,eg.orig_nli.size()-1,eg.orig_nli);
   }
}

double stringClassifier::giveProb(int s, int e, example &eg) const {
   assert(trained);
   if (cp.learnable) {
      if (!nopos && !noneg) {
	 double r = c.giveP(s,e,eg);
	 if (r < lim) return 0; 
	 else return r;
      }
      else return 0;
   }
   else {
      return giveProb(s,e,eg.orig_nli);
   }
}

double stringClassifier::giveProb(int s, int e, const vector <int> &st) const {
   /*
   if (cp.learnable) {
      assert(false);
      if (!nopos && !noneg) {
	 double r = c.giveP(s,e,st);
	 if (r < lim) return 0; 
	 else return r;
      }
      else return 0;
   }*/
      double r;
      if (cp.patPresent(st,s,e)) {
	 r=1;
	 // if two constants present then it's like a neg example
	 int a=0;
	 for (int i=s; i<=e; ++i) {
	    if (production::ifNt(n2s[st[i]])) ++a;
	    if (a==2) break;
	 }
	 if (a > 1) {
	    r = 0;
	 }
      }
      else r=0;
      if (r < lim) return 0; 
      else return r;
}
