#ifndef _STRINGCLASSIFIER_H
#define _STRINGCLASSIFIER_H

#include "pn.h"
#include "production.h"
#include "svm_kernel_classifier.h"
#include "example.h"

class stringClassifier {
   vector <pn> pos, neg;

   //naiveBayes c;
   //adatron c;
   //svm_classifier c; // explicit features
   //perceptron c;
   svm_kernel_classifier c;
   //boosted_classifier c;
   production cp;
   bool trained;
   bool nopos, noneg;

   double lim;

   double giveProb(const vector <int> &st) const;
   double giveProb(int s, int e, const vector <int> &st) const;

   public:
      stringClassifier () {
	 trained = false;
	 noneg=false;
	 nopos=false;
      }

      void train(const vector <pn> &pos, const vector <pn> &neg, const production &p);
      void train_semi(const vector <pn> &pos, const vector <pn> &neg, const vector <pn> &un, const production &p);
      double giveProb(example &eg) const;
      double giveProb(int s, int e, example &eg) const;
};

#endif
